local _, class = UnitClass("player")
if class == "DEATHKNIGHT" then

local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterEvent("UNIT_AURA")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")


local Jogador = CreateFrame("Frame", nil, UIParent)
	Jogador.Textura = Jogador:CreateTexture(nil,"BACKGROUND")
	Jogador.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\CLASS_DEATHKNIGHT")
	Jogador.Textura:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Jogador.Textura:SetSize(200,200)
	
	Jogador.SubTextura = Pulso:CreateTexture(nil,"BORDER")
	Jogador.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\DEATHKNIGHT")
	Jogador.SubTextura:SetPoint("CENTER", Jogador.Textura)
	Jogador.SubTextura:SetSize(200,200)
	Jogador.SubTextura:SetAlpha(0)
	
	Jogador.Textura1 = Jogador:CreateTexture(nil,"BACKGROUND")
	Jogador.Textura1:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\0")
	Jogador.Textura1:SetPoint("CENTER", Jogador.Textura, "BOTTOM", -48, 16)
	Jogador.Textura1:SetSize(64,64)
	
	Jogador.Textura2 = Jogador:CreateTexture(nil,"BACKGROUND")
	Jogador.Textura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\0")
	Jogador.Textura2:SetPoint("CENTER", Jogador.Textura, "BOTTOM", 0, 0)
	Jogador.Textura2:SetSize(64,64)
	
	Jogador.Textura3 = Jogador:CreateTexture(nil,"BACKGROUND")
	Jogador.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\0")
	Jogador.Textura3:SetPoint("CENTER", Jogador.Textura, "BOTTOM", 48, 16)
	Jogador.Textura3:SetSize(64,64)
	
local Alvo = CreateFrame("Frame", nil, UIParent)
	Alvo.Textura = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo.Textura:SetSize(200,200)
	
	Alvo.SubTextura = Pulso:CreateTexture(nil,"BORDER")
	Alvo.SubTextura:SetPoint("CENTER", Alvo.Textura)
	Alvo.SubTextura:SetSize(200,200)
	Alvo.SubTextura:SetAlpha(0)
	
	Alvo.Textura1 = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura1:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\0")
	Alvo.Textura1:SetPoint("CENTER", Alvo.Textura, "BOTTOM", -48, 16)
	Alvo.Textura1:SetSize(64,64)
	
	Alvo.Textura2 = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\0")
	Alvo.Textura2:SetPoint("CENTER", Alvo.Textura, "BOTTOM", 0, 0)
	Alvo.Textura2:SetSize(64,64)
	
	Alvo.Textura3 = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\0")
	Alvo.Textura3:SetPoint("CENTER", Alvo.Textura, "BOTTOM", 48, 16)
	Alvo.Textura3:SetSize(64,64)

--// Animations

	Pulso.AgFade = Pulso:CreateAnimationGroup()
	local FadeOut = Pulso.AgFade:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(1)
	FadeOut:SetOrder(1)
	local FadeIn = Pulso.AgFade:CreateAnimation("Alpha")
	FadeIn:SetFromAlpha(1)
	FadeIn:SetToAlpha(0)
	FadeIn:SetDuration(1)
	FadeIn:SetOrder(2)

local function OnFinished(self)
	self:Play()
	-- Necessário para que não seja aplicado o alpha sem animação,o Play precisa estar fora
	if not UnitAffectingCombat("player") then
		self:Stop()
	end
end Pulso.AgFade:SetScript("OnFinished", OnFinished)

local function OnPlay(self)
	Jogador.SubTextura:SetAlpha(1)
	Alvo.SubTextura:SetAlpha(1)
end Pulso.AgFade:SetScript("OnPlay", OnPlay)

-- Necessário pois se for colocado no evento PLAYER_REGEN_ENABLED o alpha será aplicado bruscamente 
local function OnStop(self)
	Jogador.SubTextura:SetAlpha(0)
	Alvo.SubTextura:SetAlpha(0)
end Pulso.AgFade:SetScript("OnStop", OnStop)


local function OnEvent(self, event)
	
	if GetSpecialization() == 1 then
		Jogador.Textura1:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\1")
		Jogador.Textura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\1")
		Jogador.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\1")
	end
	if GetSpecialization() == 2 then
		Jogador.Textura1:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\2")
		Jogador.Textura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\2")
		Jogador.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\2")
	end
	if GetSpecialization() == 3 then
		Jogador.Textura1:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\3")
		Jogador.Textura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\3")
		Jogador.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\3")
	end
	
	local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
	if hp < 30 then Jogador.Textura3:Hide() Jogador.Textura2:Hide() Jogador.Textura1:Hide() end
	if hp > 30 and hp < 60 then Jogador.Textura3:Hide() Jogador.Textura2:Hide() Jogador.Textura1:Show() end
	if hp > 60 and hp < 90 then Jogador.Textura3:Hide() Jogador.Textura2:Show() Jogador.Textura1:Show() end
	if hp > 90 then Jogador.Textura3:Show() Jogador.Textura2:Show() Jogador.Textura1:Show() end
	
	if UnitExists("target") then
	
		local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
		if hp < 30 then Alvo.Textura3:Hide() Alvo.Textura2:Hide() Alvo.Textura1:Hide() end
		if hp > 30 and hp < 60 then Alvo.Textura3:Hide() Alvo.Textura2:Hide() Alvo.Textura1:Show() end
		if hp > 60 and hp < 90 then Alvo.Textura3:Hide() Alvo.Textura2:Show() Alvo.Textura1:Show() end
		if hp > 90 then Alvo.Textura3:Show() Alvo.Textura2:Show() Alvo.Textura1:Show() end
		
		local _, class = UnitClass("target")
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\CLASS_"..class)
		Alvo.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Deathknight\\"..class)
		
		if UnitIsDeadOrGhost("target") then
			Alvo.Textura:SetDesaturated(true)
			Alvo.SubTextura:SetDesaturated(true)
		else
			Alvo.Textura:SetDesaturated(false)
			Alvo.SubTextura:SetDesaturated(false)
		end		
		
		Alvo:Show()
		Alvo.SubTextura:Show()
	else
		Alvo:Hide()
		Alvo.SubTextura:Hide()
	end	
	
	if UnitIsDeadOrGhost("player") then
		Jogador.Textura:SetDesaturated(true)
		Jogador.SubTextura:SetDesaturated(true)
	else
		Jogador.Textura:SetDesaturated(false)
		Jogador.SubTextura:SetDesaturated(false)
	end
	
	if event == "PLAYER_REGEN_DISABLED" then
		Pulso.AgFade:Play()
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end