local _, class = UnitClass("player")
if class == "DEMONHUNTER" then


local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")
	Pulso:SetFrameStrata("BACKGROUND")
	Pulso:SetFrameLevel(0)


	
local Player = Pulso:CreateTexture(nil,"LOW")
	Player:SetTexture("Interface\\AddOns\\Pulso\\Images\\Demonhunter\\Life_Border")
	Player:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player:SetSize(128,128)	
	
	Player.Text = Pulso:CreateFontString(nil, "LOW")
	Player.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Demonhunter.ttf", 15)
	Player.Text:SetPoint("CENTER", Player)
	Player.Text:SetTextColor(0,1,0)
	Player.Text:SetShadowColor(1,1,1)
	Player.Text:SetShadowOffset(1,-1)

local Alvo = Pulso:CreateTexture(nil,"LOW")
	Alvo:SetTexture("Interface\\AddOns\\Pulso\\Images\\Demonhunter\\Life_Border")
	Alvo:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo:SetSize(128,128)
	Alvo:SetTexCoord(1,0,0,1)	

	Alvo.Text = Pulso:CreateFontString(nil, "LOW")
	Alvo.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Demonhunter.ttf", 15)
	Alvo.Text:SetPoint("CENTER", Alvo)
	Alvo.Text:SetTextColor(0,1,0)
	Alvo.Text:SetShadowColor(1,1,1)
	Alvo.Text:SetShadowOffset(1,-1)

	local Textura = Pulso:CreateTexture(nil,"BACKGROUND")
	Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Demonhunter\\Textura")
	Textura:SetPoint("CENTER", UIParent)
	Textura:SetSize(512,512)

	local Top = Pulso:CreateTexture(nil,"BACKGROUND")
	Top:SetTexture("Interface\\AddOns\\Pulso\\Images\\Demonhunter\\Fundo")
	Top:SetPoint("BOTTOM", Textura, "TOP")
	Top:SetSize(Textura:GetWidth(),((GetScreenHeight()/2) - 256))
	
	local Bottom = Pulso:CreateTexture(nil,"BACKGROUND")
	Bottom:SetTexture("Interface\\AddOns\\Pulso\\Images\\Demonhunter\\Fundo")
	Bottom:SetPoint("TOP", Textura, "BOTTOM")
	Bottom:SetSize(Textura:GetWidth(),((GetScreenHeight()/2) - 256))

	local Left = Pulso:CreateTexture(nil,"BACKGROUND")
	Left:SetTexture("Interface\\AddOns\\Pulso\\Images\\Demonhunter\\Fundo")
	Left:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT")
	Left:SetSize(((GetScreenWidth()/2) - 256), GetScreenHeight())
	
	local Right = Pulso:CreateTexture(nil,"BACKGROUND")
	Right:SetTexture("Interface\\AddOns\\Pulso\\Images\\Demonhunter\\Fundo")
	Right:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT")
	Right:SetSize(((GetScreenWidth()/2) - 256), GetScreenHeight())
	
	Pulso.AgFade = Pulso:CreateAnimationGroup()
	local Fade = Pulso.AgFade:CreateAnimation("Alpha")
	Fade:SetDuration(.5)
	Fade:SetOrder(1)

	Pulso:SetAlpha(0)


local function OnPlay(self)
	Pulso:Show()
end Pulso.AgFade:SetScript("OnPlay", OnPlay)

local function OnStop(self)
	Pulso:Hide()
end Pulso.AgFade:SetScript("OnStop", OnStop)


local function OnEvent(self, event)

	local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
	Player.Text:SetFormattedText("%.0f", hp)
	
	if UnitExists("target") then
		local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
		Alvo.Text:SetFormattedText("%.0f", hp)
		
		Alvo.Text:Show()
	else
		Alvo.Text:Hide()
	end
	
	if event == "PLAYER_REGEN_DISABLED" then
		Fade:SetFromAlpha(0)
		Fade:SetToAlpha(1)
		Pulso:SetAlpha(1)
		Pulso.AgFade:Play()
	elseif event == "PLAYER_REGEN_ENABLED" then
		Fade:SetFromAlpha(1)
		Fade:SetToAlpha(0)
		Pulso:SetAlpha(0)
		Pulso.AgFade:Play()
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end