local _, class = UnitClass("player")
if class == "PALADIN" then

local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterEvent("UNIT_TARGET")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")


local Player = CreateFrame("Frame", nil, UIParent)
	Player.Textura = Pulso:CreateTexture(nil,"BACKGROUND")
	Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\1")
	Player.Textura:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player.Textura:SetSize(32,32)
	Player.Textura:SetTexCoord(1,0,0,1)
	
	Player.Textura2 = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura2:SetPoint("CENTER", Player.Textura)
	Player.Textura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\0")
	Player.Textura2:SetSize(200,200)
	Player.Textura2:SetBlendMode("ADD")
	
	Player.Textura3 = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura3:SetPoint("CENTER", Player.Textura)
	Player.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\a")
	Player.Textura3:SetSize(200,200)


local Alvo = CreateFrame("Frame", nil, UIParent)
	Alvo.Textura = Pulso:CreateTexture(nil,"BORDER")
	Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\1")
	Alvo.Textura:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo.Textura:SetSize(32,32)
	
	Alvo.Textura2 = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura2:SetPoint("CENTER", Alvo.Textura)
	Alvo.Textura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\0")
	Alvo.Textura2:SetSize(200,200)
	Alvo.Textura2:SetBlendMode("ADD")
	
	Alvo.Textura3 = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura3:SetPoint("CENTER", Alvo.Textura)
	Alvo.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\a")
	Alvo.Textura3:SetSize(200,200)
	


--// Animations

	Pulso.AgFadeIn = Pulso:CreateAnimationGroup()
	local FadeIn = Pulso.AgFadeIn:CreateAnimation("Alpha")
	FadeIn:SetFromAlpha(1)
	FadeIn:SetToAlpha(0)
	FadeIn:SetDuration(1)
	FadeIn:SetOrder(1)
	
	Pulso.AgFadeOut = Pulso:CreateAnimationGroup()
	local FadeOut = Pulso.AgFadeOut:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(1)
	FadeOut:SetOrder(1)

local combate
local function OnFinished(self)
	
	if UnitAffectingCombat("player") then
		local r = math.random(1,11)
		-- local a = math.random(1,11)
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\Combate_"..r)
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\Combate_"..r)
		combate = true
	else
		local r = math.random(1,11)
		-- local a = math.random(1,11)
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\"..r)
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\"..r)
		combate = false
	end
	
	Pulso.AgFadeOut:Play()

end Pulso.AgFadeIn:SetScript("OnFinished", OnFinished)

local function FinishedOut(self)
	
	if combate then
		Pulso.AgFadeIn:Play()
	end

end Pulso.AgFadeOut:SetScript("OnFinished", FinishedOut)



local function OnEvent(self, event)
	
	local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
	if hp < 1 then Player.Textura3:Hide() end
	if hp > 1  then Player.Textura3:Show() Player.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\25") end
	if hp > 25 then Player.Textura3:Show() Player.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\50") end
	if hp > 50 then Player.Textura3:Show() Player.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\75") end
	if hp > 75 then Player.Textura3:Show() Player.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\100") end

	if UnitExists("target") then
		local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
		if hp < 1 then Alvo.Textura3:Hide() end
		if hp > 1  then Alvo.Textura3:Show() Alvo.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\25") end
		if hp > 25 then Alvo.Textura3:Show() Alvo.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\50") end
		if hp > 50 then Alvo.Textura3:Show() Alvo.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\75") end
		if hp > 75 then Alvo.Textura3:Show() Alvo.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Paladin\\100") end
		
		Alvo:Show()
		Alvo.Textura:Show()
	else
		Alvo:Hide()
		Alvo.Textura:Hide()
	end
	
	if event == "PLAYER_REGEN_DISABLED" then
		Pulso.AgFadeIn:Play()
	elseif event == "PLAYER_REGEN_ENABLED" then
		-- Pulso.AgFade:Stop()
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end