local _, class = UnitClass("player")
if class == "PRIEST" then


local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	-- Pulso:RegisterEvent("UNIT_TARGET")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("UNIT_AURA")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")

local Pulse = CreateFrame("Frame", nil, UIParent)

local Player = CreateFrame("Frame", nil, UIParent)
	Player:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player:SetSize(1,1)
	
	Player.Discipline = Pulse:CreateTexture(nil,"BORDER")
	Player.Discipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Discipline_Pulse_White")
	Player.Discipline:SetPoint("CENTER", Player)
	Player.Discipline:SetSize(128,128)
	Player.Discipline:SetAlpha(1)

	Player.SubDiscipline = Pulso:CreateTexture(nil,"BACKGROUND")
	Player.SubDiscipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\24")
	Player.SubDiscipline:SetPoint("CENTER", Player)
	Player.SubDiscipline:SetSize(128,128)
	Player.SubDiscipline:SetVertexColor(0,0,0)
	Player.SubDiscipline:SetAlpha(0)

	Player.Holy = Player:CreateTexture(nil,"BORDER")
	Player.Holy:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Holy_Borde")
	Player.Holy:SetPoint("CENTER", Player)
	Player.Holy:SetSize(256,256)

	Player.SubHoly = Pulso:CreateTexture(nil,"BACKGROUND")
	Player.SubHoly:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Holy_Pulse")
	Player.SubHoly:SetPoint("CENTER", Player)
	Player.SubHoly:SetSize(256,256)
	Player.SubHoly:SetAlpha(0)
	
	Player.Shadow = Pulse:CreateTexture(nil,"BORDER")
	Player.Shadow:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Shadow_White")
	Player.Shadow:SetPoint("CENTER", Player)
	Player.Shadow:SetSize(256,256)

	Player.Text = Player:CreateFontString(nil, "BORDER")
	Player.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Priest.ttf", 24)
	Player.Text:SetPoint("CENTER", Player)
	Player.Text:SetTextColor(1,1,1)
	Player.Text:SetShadowColor(0,0,0)
	Player.Text:SetShadowOffset(1,-1)

local Alvo = CreateFrame("Frame", nil, UIParent)
	Alvo:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo:SetSize(128,128)
	
	Alvo.Discipline = Pulse:CreateTexture(nil,"BORDER")
	Alvo.Discipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Discipline_Pulse_Black")
	Alvo.Discipline:SetPoint("CENTER", Alvo)
	Alvo.Discipline:SetSize(128,128)

	Alvo.SubDiscipline = Pulso:CreateTexture(nil,"BACKGROUND")
	Alvo.SubDiscipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\24")
	Alvo.SubDiscipline:SetPoint("CENTER", Alvo)
	Alvo.SubDiscipline:SetSize(128,128)
	Alvo.SubDiscipline:SetAlpha(0)
	
	Alvo.Holy = Alvo:CreateTexture(nil,"BORDER")
	Alvo.Holy:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Holy_Borde")
	Alvo.Holy:SetPoint("CENTER", Alvo)
	Alvo.Holy:SetSize(256,256)

	Alvo.SubHoly = Pulso:CreateTexture(nil,"BACKGROUND")	
	Alvo.SubHoly:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Holy_Pulse")
	Alvo.SubHoly:SetPoint("CENTER", Alvo)
	Alvo.SubHoly:SetSize(256,256)
	Alvo.SubHoly:SetAlpha(0)
	
	Alvo.Shadow = Pulse:CreateTexture(nil,"BORDER")
	Alvo.Shadow:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Shadow_White")
	Alvo.Shadow:SetPoint("CENTER", Alvo)
	Alvo.Shadow:SetSize(256,256)
	
	Alvo.Text = Alvo:CreateFontString(nil, "BORDER")
	Alvo.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Priest.ttf", 24)
	Alvo.Text:SetPoint("CENTER", Alvo)
	Alvo.Text:SetTextColor(1,1,1)
	Alvo.Text:SetShadowColor(0,0,0)
	Alvo.Text:SetShadowOffset(1,-1)

--// Animations

	Pulso.AgFade = Pulso:CreateAnimationGroup()
	local FadeOut = Pulso.AgFade:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(1)
	FadeOut:SetOrder(1)
	local FadeIn = Pulso.AgFade:CreateAnimation("Alpha")
	FadeIn:SetFromAlpha(1)
	FadeIn:SetToAlpha(0)
	FadeIn:SetDuration(1)
	FadeIn:SetOrder(2)

	Pulse.AgFadeIn = Pulse:CreateAnimationGroup()
	local PlayerFadeIn = Pulse.AgFadeIn:CreateAnimation("Alpha")
	PlayerFadeIn:SetFromAlpha(1)
	PlayerFadeIn:SetToAlpha(0)
	PlayerFadeIn:SetDuration(1)
	PlayerFadeIn:SetOrder(1)
	
	Pulse.AgFadeOut = Pulse:CreateAnimationGroup()
	local PlayerFadeOut = Pulse.AgFadeOut:CreateAnimation("Alpha")
	PlayerFadeOut:SetFromAlpha(0)
	PlayerFadeOut:SetToAlpha(1)
	PlayerFadeOut:SetDuration(1)
	PlayerFadeOut:SetOrder(1)


--------------------|| OnPlay ||--------------------
local function OnPlay(self)

	-- Discipline
	if GetSpecialization() == 1 then
		Player.SubDiscipline:SetAlpha(1)
		Alvo.SubDiscipline:SetAlpha(1)
	end
	

	-- Holy
	if GetSpecialization() == 2 then
		Player.SubHoly:SetAlpha(1)
		Alvo.SubHoly:SetAlpha(1)
	end

end Pulso.AgFade:SetScript("OnPlay", OnPlay)


--------------------|| OnStop ||--------------------
local count = 0
local function OnStop(self)
	
	-- Discipline
	if GetSpecialization() == 1 then
		Player.SubDiscipline:SetAlpha(0)
		Alvo.SubDiscipline:SetAlpha(0)
		count = 24
		Player.SubDiscipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\"..count)
		Alvo.SubDiscipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\"..count)
	end

	-- Holy
	if GetSpecialization() == 2 then
		Player.SubHoly:SetAlpha(0)
		Alvo.SubHoly:SetAlpha(0)
	end

end Pulso.AgFade:SetScript("OnStop", OnStop)


--------------------|| OnFinished ||--------------------
local function OnFinished(self)
	
	-- Discipline
	if GetSpecialization() == 1 then
		if count == 24 then
			count = 0
		end
		count = count + 1
		Player.SubDiscipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\"..count)
		Alvo.SubDiscipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\"..count)
	end
	
	self:Play()
	if not UnitAffectingCombat("player") then
		self:Stop()
	end

end Pulso.AgFade:SetScript("OnFinished", OnFinished)

local function FinishedIn(self)
	
	-- Discipline
	if GetSpecialization() == 1 then
		if Player.Discipline:GetTexture() == "Interface\\AddOns\\Pulso\\Images\\Priest\\Discipline_Pulse_White" then
			Player.Discipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Discipline_Pulse_Black")
			Alvo.Discipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Discipline_Pulse_White")
		else
			Player.Discipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Discipline_Pulse_White")
			Alvo.Discipline:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Discipline_Pulse_Black")
		end
	end
	
	-- Shadow
	if GetSpecialization() == 3 then
		if Player.Shadow:GetTexture() == "Interface\\AddOns\\Pulso\\Images\\Priest\\Shadow_Black" then
			Player.Shadow:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Shadow_White")
			Alvo.Shadow:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Shadow_White")
		else
			Player.Shadow:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Shadow_Black")
			Alvo.Shadow:SetTexture("Interface\\AddOns\\Pulso\\Images\\Priest\\Shadow_Black")
		end
	end
	
	Pulse.AgFadeOut:Play()

end Pulse.AgFadeIn:SetScript("OnFinished", FinishedIn)

local function FinishedOut(self)
	
	-- Shadow
	if GetSpecialization() == 3 and UnitAffectingCombat("player") then
		Pulse.AgFadeIn:Play()
	end

end Pulse.AgFadeOut:SetScript("OnFinished", FinishedOut)


--------------------|| OnEvent ||--------------------
local function OnEvent(self, event)
	
	local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
	Player.Text:SetFormattedText("%.0f", hp)
	
	

	-- Discipline
	if GetSpecialization() == 1 then
		Player.Discipline:Show()
		Player.SubDiscipline:Show()
		Player.Text:Hide()
		Alvo.Text:Hide()
		Player.Discipline:SetAlpha((hp/100)+.1)
		if UnitExists("target") then
			Alvo.Discipline:Show()
			Alvo.SubDiscipline:Show()
			local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
			Alvo.Discipline:SetAlpha((hp/100)+.1)
		else
			Alvo.Discipline:Hide()
			Alvo.SubDiscipline:Hide()
		end
	else
		Player.Discipline:Hide()
		Player.SubDiscipline:Hide()
		Alvo.Discipline:Hide()
		Alvo.SubDiscipline:Hide()
		Player.Text:Show()
		if UnitExists("target") then
			Alvo.Text:Show()
		end
	end
	
	-- Holy
	if GetSpecialization() == 2 then
		Player.Holy:Show()
		Player.SubHoly:Show()
		if UnitExists("target") then
			Alvo.Holy:Show()
			Alvo.SubHoly:Show()
		else
			Alvo.Holy:Hide()
			Alvo.SubHoly:Hide()
		end
	else
		Player.Holy:Hide()
		Player.SubHoly:Hide()
		Alvo.Holy:Hide()
		Alvo.SubHoly:Hide()
	end
	
	-- Shadow
	if GetSpecialization() == 3 then
		Player.Shadow:Show()
		if UnitExists("target") then
			Alvo.Shadow:Show()
		else
			Alvo.Shadow:Hide()
		end
	else
		Player.Shadow:Hide()
		Alvo.Shadow:Hide()
	end

	if UnitExists("target") then
		local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
		Alvo.Text:SetFormattedText("%.0f", hp)
		Alvo:Show()
	else
		Alvo:Hide()
	end

	--------------------|| Combate ||--------------------
	if event == "PLAYER_REGEN_DISABLED" then
		Pulso.AgFade:Play()
		if GetSpecialization() == 3 then
			Pulse.AgFadeIn:Play()
		end
	elseif event == "PLAYER_REGEN_ENABLED" then
		if GetSpecialization() == 1 then
			Pulse.AgFadeIn:Play()
		end
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end