local _, class = UnitClass("player")
if class == "ROGUE" then


local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("UNIT_POWER_FREQUENT")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")

local Player = CreateFrame("Frame", nil, Pulso)
	Player.Textura = Player:CreateTexture(nil,"BORDER")
	Player.Textura:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player.Textura:SetSize(64,256)
	Player.Textura:SetBlendMode("ADD")
	
	Player.Textura:SetTexCoord(1,0,0,1)

local Alvo = CreateFrame("Frame", nil, Pulso)
	Alvo.Textura = Alvo:CreateTexture(nil,"BORDER")
	Alvo.Textura:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo.Textura:SetSize(64,256)
	Alvo.Textura:SetBlendMode("ADD")
	

--// Animations

	Pulso.AgFade = Pulso:CreateAnimationGroup()
	local FadeOut = Pulso.AgFade:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(.2)
	FadeOut:SetOrder(1)
	
	Player.AgFade = Player:CreateAnimationGroup()
	local FadeOut = Player.AgFade:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(.3)
	FadeOut:SetOrder(1)
	
	Alvo.AgFade = Alvo:CreateAnimationGroup()
	local FadeOut = Alvo.AgFade:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(.3)
	FadeOut:SetOrder(1)


local checkPlayer, checkCombo = true
local function AplicarTextura(combo, health)	

	if not UnitAffectingCombat("player") or combo == 0 then
		Alvo.Textura:SetBlendMode("ADD")
	else
		Alvo.Textura:SetBlendMode("BLEND")
	end

	if combo == 0 then
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Rogue\\3_"..health)
	elseif combo > 0 and combo <= 2 then
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Rogue\\1_"..health)
	elseif combo > 2 and combo <= 4 then
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Rogue\\2_"..health)
	elseif combo > 4 then
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Rogue\\3_"..health)
	end
	
	if checkCombo ~= combo then
		Alvo.AgFade:Play()
		checkCombo = combo
	end
end


local function OnEvent(self, event)

	local comboPoints = GetComboPoints("player", "target")
	
	-- Frame do Player
	if UnitExists("target") and UnitHealth("player") < UnitHealth("target") then
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Rogue\\3_Menor")
		if not checkPlayer then
			Player.AgFade:Play()			
			checkPlayer = true
		end
	else
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Rogue\\3_Maior")
		if checkPlayer then			
			Player.AgFade:Play()
			checkPlayer = false
		end
	end
	
	-- Frame do Alvo
	if UnitClass("target") then
		if UnitHealthMax("player") < UnitHealthMax("target") then
			AplicarTextura(comboPoints, "Maior")
		else
			AplicarTextura(comboPoints, "Menor")
		end		
		Alvo:Show()
	else
		Alvo:Hide()
	end
	
	if event == "PLAYER_TARGET_CHANGED" then
		Pulso.AgFade:Play()
	end
	
	if event == "PLAYER_REGEN_DISABLED" then
		Player.Textura:SetBlendMode("BLEND")		
	elseif event == "PLAYER_REGEN_ENABLED" then
		Player.Textura:SetBlendMode("ADD")			
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end