local _, class = UnitClass("player")
if class == "WARRIOR" then

local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")

local factionP, _ = UnitFactionGroup("player")
local Player = CreateFrame("Frame", nil, Pulso)
	Player.Textura = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warrior\\"..factionP..factionP)
	Player.Textura:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player.Textura:SetSize(80,80)
	
	Player.Textura1 = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura1:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warrior\\Life")
	Player.Textura1:SetPoint("CENTER", Player.Textura, "BOTTOM", -48, -50)
	Player.Textura1:SetSize(48,48)
	
	Player.Textura2 = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warrior\\Life")
	Player.Textura2:SetPoint("CENTER", Player.Textura, "BOTTOM", 0, -50)
	Player.Textura2:SetSize(48,48)
	
	Player.Textura3 = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warrior\\Life")
	Player.Textura3:SetPoint("CENTER", Player.Textura, "BOTTOM", 48, -50)
	Player.Textura3:SetSize(48,48)
	

local Alvo = CreateFrame("Frame", nil, Pulso)
	Alvo.Textura = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo.Textura:SetSize(80,80)
	
	Alvo.Textura1 = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura1:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warrior\\Life")
	Alvo.Textura1:SetPoint("CENTER", Alvo.Textura, "BOTTOM", -48, -50)
	Alvo.Textura1:SetSize(48,48)
	Alvo.Textura1:SetVertexColor(0,0,0)
	
	Alvo.Textura2 = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warrior\\Life")
	Alvo.Textura2:SetPoint("CENTER", Alvo.Textura, "BOTTOM", 0, -50)
	Alvo.Textura2:SetSize(48,48)
	Alvo.Textura2:SetVertexColor(0,0,0)
	
	Alvo.Textura3 = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura3:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warrior\\Life")
	Alvo.Textura3:SetPoint("CENTER", Alvo.Textura, "BOTTOM", 48, -50)
	Alvo.Textura3:SetSize(48,48)
	Alvo.Textura3:SetVertexColor(0,0,0)

--// Animations

	Pulso.AgFadeIn = Pulso:CreateAnimationGroup()
	local FadeIn = Pulso.AgFadeIn:CreateAnimation("Alpha")
	FadeIn:SetFromAlpha(1)
	FadeIn:SetToAlpha(0)
	FadeIn:SetDuration(1)
	FadeIn:SetOrder(1)

	Pulso.AgFadeOut = Pulso:CreateAnimationGroup()
	local FadeOut = Pulso.AgFadeOut:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(1)
	FadeOut:SetOrder(1)

--------------------|| OnFinished ||--------------------
local function OnFinished(self)
	Pulso.AgFadeOut:Play()
end Pulso.AgFadeIn:SetScript("OnFinished", OnFinished)

local function OnFinishedOut(self)
	if UnitAffectingCombat("player") then
		Pulso.AgFadeIn:Play()
	end
end Pulso.AgFadeOut:SetScript("OnFinished", OnFinishedOut)


local function OnEvent(self, event)
	
	local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
	if hp < 30 then Player.Textura3:Hide() Player.Textura2:Hide() Player.Textura1:Hide() end
	if hp > 30 and hp < 60 then Player.Textura3:Hide() Player.Textura2:Hide() Player.Textura1:Show() end
	if hp > 60 and hp < 90 then Player.Textura3:Hide() Player.Textura2:Show() Player.Textura1:Show() end
	if hp > 90 then Player.Textura3:Show() Player.Textura2:Show() Player.Textura1:Show() end

	if UnitExists("target") then
		local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
		if hp < 30 then Alvo.Textura3:Hide() Alvo.Textura2:Hide() Alvo.Textura1:Hide() end
		if hp > 30 and hp < 60 then Alvo.Textura3:Hide() Alvo.Textura2:Hide() Alvo.Textura1:Show() end
		if hp > 60 and hp < 90 then Alvo.Textura3:Hide() Alvo.Textura2:Show() Alvo.Textura1:Show() end
		if hp > 90 then Alvo.Textura3:Show() Alvo.Textura2:Show() Alvo.Textura1:Show() end
	
		if UnitFactionGroup("target") then
			local factionA, _ = UnitFactionGroup("target")
			Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warrior\\"..factionP..factionA)
		else
			Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warrior\\"..factionP.."Environment")
		end
		Alvo:Show()
	else
		Alvo:Hide()
	end

	if event == "PLAYER_REGEN_DISABLED" then
		Pulso.AgFadeIn:Play()
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end