local _, class = UnitClass("player")
if class == "DRUID" then

local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterUnitEvent("UNIT_AURA", "player")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")


local Player = CreateFrame("Frame", nil, UIParent)
	Player.Life = Player:CreateTexture(nil,"BACKGROUND")
	Player.Life:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player.Life:SetSize(64,64)
	Player.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\Humano")
	
	Player.Textura = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura:SetPoint("BOTTOM", Player.Life, "TOP", 0, -16)
	Player.Textura:SetSize(64,64)
	
	Player.SubTextura = Pulso:CreateTexture(nil,"BACKGROUND")
	Player.SubTextura:SetPoint("BOTTOM", Player.Textura, "TOP", 0, -16)
	Player.SubTextura:SetSize(64,64)
	
	

local Alvo = CreateFrame("Frame", nil, UIParent)
	Alvo.Life = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Life:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo.Life:SetSize(64,64)
	Alvo.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\Humano")
	
	Alvo.Textura = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura:SetPoint("BOTTOM", Alvo.Life, "TOP", 0, -16)
	Alvo.Textura:SetSize(64,64)
	
	Alvo.SubTextura = Pulso:CreateTexture(nil,"BACKGROUND")
	Alvo.SubTextura:SetPoint("BOTTOM", Alvo.Textura, "TOP", 0, -16)
	Alvo.SubTextura:SetSize(64,64)

--// Animations

	Pulso.AgFade = Pulso:CreateAnimationGroup()
	local FadeOut = Pulso.AgFade:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(1)
	FadeOut:SetOrder(1)
	
local Forma, SubForma, Aura
local function OnEvent(self, event)

	
	if C_Map.GetBestMapForUnit("player") and C_Map.GetBestMapForUnit("player") == 80 then
		Player.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\Moonglade")
	else
		local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
		if hp >= 0   then Player.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\0") end
		if hp >= 25  then Player.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\25") end
		if hp >= 50  then Player.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\50") end
		if hp >= 100 then Player.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\100") end
	end
	
	local i = 1
	local Aura = nil
	while UnitAura("player",i) do
		if (UnitAura("player",i) == "Moonkin Form" or UnitAura("player",i) == "Travel Form" or UnitAura("player",i) == "Cat Form" or UnitAura("player",i) == "Bear Form" or UnitAura("player",i) == "Forma de Luniscante" or UnitAura("player",i) == "Forma de Viagem" or UnitAura("player",i) == "Forma de Felino" or UnitAura("player",i) == "Forma de Urso") then
			Aura = UnitAura("player",i)
		end
		i = i + 1
	end

	if C_Map.GetBestMapForUnit("player") and C_Map.GetBestMapForUnit("player") == 80 then
		Forma = "Moonglade"
	elseif UnitIsDeadOrGhost("player") then
		Forma = "Morto"
	elseif Aura and (Aura == "Forma de Luniscante" or Aura == "Moonkin Form") then
		Forma = "Luniscante"
	elseif  Aura and (Aura == "Forma de Viagem" or Aura == "Travel Form") then
		Forma = "Viagem"
	elseif Aura and (Aura == "Forma de Felino" or Aura == "Cat Form") then
		Forma = "Felino"
	elseif Aura and (Aura == "Forma de Urso" or Aura == "Bear Form") then
		Forma = "Urso"
	else
		Forma = "Humano"
	end

	if UnitAffectingCombat("player") then
		SubForma = "Combate"
	else
		SubForma = Forma
	end
	
	Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\"..Forma)
	Player.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\"..SubForma)

	if UnitExists("target") then
		
		if C_Map.GetBestMapForUnit("target") and C_Map.GetBestMapForUnit("target") == 80 then
			Alvo.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\Moonglade")
			Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\Moonglade")
			Alvo.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\Moonglade")
		else
			local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
			if hp >= 0   then Alvo.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\0") end
			if hp >= 25  then Alvo.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\25") end
			if hp >= 50  then Alvo.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\50") end
			if hp >= 100 then Alvo.Life:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\100") end
			
			if UnitIsDeadOrGhost("target") then
				Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\Morto")
				Alvo.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\Morto")
			else
				Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\"..Forma)
				Alvo.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Druid\\"..SubForma)
			end
		end
		
		
		Alvo:Show()
		Alvo.SubTextura:Show()
	else
		Alvo:Hide()
		Alvo.SubTextura:Hide()
	end
	
	if event == "PLAYER_REGEN_DISABLED" then
		Pulso.AgFade:Play()
	elseif event == "PLAYER_REGEN_ENABLED" then
		Pulso.AgFade:Play()
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end