local _, class = UnitClass("player")
if class == "SHAMAN" then

local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterEvent("UNIT_AURA")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")

-- Não remover Player/Alvo Frames, pq os loops necessitam deles para se moverem de forma una.
local Player = CreateFrame("Frame", nil, Pulso)
	Player:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player:SetSize(128,128)
	
	Player.Text = Player:CreateFontString(nil, "BORDER")
	Player.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Shaman.ttf", 19)
	Player.Text:SetPoint("CENTER", Player)
	Player.Text:SetTextColor(.1,.1,.1)
	Player.Text:SetShadowColor(.2,.2,.2)
	Player.Text:SetShadowOffset(1,-1)
	
	Player.Textura = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\5")
	Player.Textura:SetPoint("CENTER")
	Player.Textura:SetSize(128,128)
	
	Player.SubTextura = Pulso:CreateTexture(nil,"BORDER")
	Player.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_3")
	Player.SubTextura:SetPoint("CENTER", Player.Textura)
	Player.SubTextura:SetSize(128,128)
	
	Player.SubTextura2 = Pulso:CreateTexture(nil,"BORDER")
	Player.SubTextura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_4")
	Player.SubTextura2:SetPoint("CENTER", Player.Textura)
	Player.SubTextura2:SetSize(128,128)
	Player.SubTextura2:SetTexCoord(0,1,1,0)

local Alvo = CreateFrame("Frame", nil, Pulso)
	Alvo:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo:SetSize(128,128)

	Alvo.Text = Alvo:CreateFontString(nil, "BORDER")
	Alvo.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Shaman.ttf", 19)
	Alvo.Text:SetPoint("CENTER", Alvo)
	Alvo.Text:SetTextColor(.1,.1,.1)
	Alvo.Text:SetShadowColor(.2,.2,.2)
	Alvo.Text:SetShadowOffset(1,-1)
	
	Alvo.Textura = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\5")
	Alvo.Textura:SetPoint("CENTER")
	Alvo.Textura:SetSize(128,128)
	
	Alvo.SubTextura = Pulso:CreateTexture(nil,"BACKGROUND")
	Alvo.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_3")
	Alvo.SubTextura:SetPoint("CENTER", Alvo.Textura)
	Alvo.SubTextura:SetSize(128, 128)
	Alvo.SubTextura:SetTexCoord(1,0,0,1)
	
	Alvo.SubTextura2 = Pulso:CreateTexture(nil,"BACKGROUND")
	Alvo.SubTextura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_4")
	Alvo.SubTextura2:SetPoint("CENTER", Alvo.Textura)
	Alvo.SubTextura2:SetSize(128, 128)
	Alvo.SubTextura2:SetTexCoord(1,0,1,0)

--// Animations

	Pulso.AgFadeIn = Pulso:CreateAnimationGroup()
	local FadeIn = Pulso.AgFadeIn:CreateAnimation("Alpha")
	FadeIn:SetFromAlpha(1)
	FadeIn:SetToAlpha(0)
	FadeIn:SetDuration(.5)
	FadeIn:SetOrder(1)

	Pulso.AgFadeOut = Pulso:CreateAnimationGroup()
	local FadeOut = Pulso.AgFadeOut:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(.5)
	FadeOut:SetOrder(1)
	
	Player.AgLoop = Player.SubTextura:CreateAnimationGroup()
	Player.AgLoop:SetLooping("REPEAT")
	Player.Loop = Player.AgLoop:CreateAnimation("Rotation")
	Player.Loop:SetDuration(4)
	Player.Loop:SetDegrees(-720)
	
	Player.AgLoop2 = Player.SubTextura2:CreateAnimationGroup()
	Player.AgLoop2:SetLooping("REPEAT")
	Player.Loop2 = Player.AgLoop2:CreateAnimation("Rotation")
	Player.Loop2:SetDuration(4)
	Player.Loop2:SetDegrees(720)

	Alvo.AgLoop = Alvo.SubTextura:CreateAnimationGroup()
	Alvo.AgLoop:SetLooping("REPEAT")
	Alvo.Loop = Alvo.AgLoop:CreateAnimation("Rotation")
	Alvo.Loop:SetDuration(4)
	Alvo.Loop:SetDegrees(720)
	
	Alvo.AgLoop2 = Alvo.SubTextura2:CreateAnimationGroup()
	Alvo.AgLoop2:SetLooping("REPEAT")
	Alvo.Loop2 = Alvo.AgLoop2:CreateAnimation("Rotation")
	Alvo.Loop2:SetDuration(4)
	Alvo.Loop2:SetDegrees(-720)
	
	Player.AgLoop:Play()
	Player.AgLoop2:Play()
	Alvo.AgLoop:Play()
	Alvo.AgLoop2:Play()

local acendance, heroism

	if GetLocale() == "enUS" and UnitFactionGroup("player") == "Alliance" then
		ascendance = "Ascendence"
		heroism = "Heroism"
	elseif GetLocale() == "enUS" and UnitFactionGroup("player") == "Horde" then
		ascendance = "Ascendence"
		heroism = "Bloodlust"
	elseif UnitFactionGroup("player") == "Horde" then
		ascendance = "Ascendência"
		heroism = "Sede de Sangue"
	else
		ascendance = "Ascendência"
		heroism = "Heroísmo"
	end

local function AplicarTextura(tex)
	if tex == "Default" then
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\5")
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\5")
		Player.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_2")
		Player.SubTextura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_4")
		Alvo.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_2")
		Alvo.SubTextura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_4")
	else	
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\"..tex)
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\"..tex)
		Player.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_"..tex)
		Player.SubTextura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_"..tex)
		Alvo.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_"..tex)
		Alvo.SubTextura2:SetTexture("Interface\\AddOns\\Pulso\\Images\\Shaman\\Elemento_"..tex)
	end
end

local function Aura(unit, aura)
	local i = 1
	while UnitAura(unit,i) do
		if UnitAura(unit,i) == aura then
			return true
		end
		i = i + 1
	end
end


local function OnFinished(self)

	if Aura("player", heroism) then
		AplicarTextura(1)
	elseif Aura("player", ascendance) and GetSpecialization() == 1 then
		AplicarTextura(2)
	elseif Aura("player", ascendance)  and GetSpecialization() == 2 then
		AplicarTextura(3)
	elseif Aura("player", ascendance) and GetSpecialization() == 3 then
		AplicarTextura(4)
	else
		AplicarTextura("Default")
	end
	Pulso.AgFadeOut:Play()

end Pulso.AgFadeIn:SetScript("OnFinished", OnFinished)


local check
local function OnEvent(self, event)

	if Aura("player", heroism)then
		if  check ~= 1 then
			Pulso.AgFadeIn:Play()
			check = 1
		end
	elseif Aura("player", ascendance) then
		if check ~= 2 then
			Pulso.AgFadeIn:Play()
			check = 2
		end
	else
		if check ~= 3 then
			Pulso.AgFadeIn:Play()
			check = 3
		end
	end
	
	local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
	Player.Text:SetFormattedText("%.0f", hp)

	if UnitExists("target") then
		local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
		Alvo.Text:SetFormattedText("%.0f", hp)
		Alvo:Show()
		Alvo.SubTextura:Show()
		Alvo.SubTextura2:Show()
	else
		Alvo:Hide()
		Alvo.SubTextura:Hide()
		Alvo.SubTextura2:Hide()		
	end

	if event == "PLAYER_REGEN_DISABLED" then
		Player.Loop:SetDuration(1)
		Player.Loop2:SetDuration(1)
		Alvo.Loop:SetDuration(1)
		Alvo.Loop2:SetDuration(1)
	elseif event == "PLAYER_REGEN_ENABLED" then
		Player.Loop:SetDuration(4)
		Player.Loop2:SetDuration(4)
		Alvo.Loop:SetDuration(4)
		Alvo.Loop2:SetDuration(4)
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end